﻿//2009.6. 5 修正　　　　　　　　　　　　******  T.ikoma ******

unit WPRCComm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

const
  ASCII_XON  = $11;                         // XON文字コード
  ASCII_XOFF = $13;                         // XOFF文字コード

//dcbコントロールコード   DWord         ｺﾝﾄﾛｰﾙ       ﾋﾞｯﾄ数  内容
  dcb_Binary           = $00000001; // fBinary:          1;	バイナリ モード､ EOFをチェックしない
  dcb_Parity           = $00000002; // fParity:          1;	パリティ チェックを有効
  dcb_OutxCtsFlow      = $00000004; // fOutxCtsFlow:     1;	CTS出力フロー制御
  dcb_OutxDsrFlow      = $00000008; // fOutxDsrFlow:     1;	DSR出力フロー制御
  dcb_Dtr_Enable       = $00000010; // fDtrControl:      2;	DTRフロー制御の種類
  dcb_Dtr_Handshake    = $00000020; //
  dcb_DsrSensitivity   = $00000040; // fDsrSensitivity:  1; DSRの感度
  dcb_TXContinueOnXoff = $00000080; // fTXContinueOnXoff:1;	XOFF後も送信を継続
  dcb_OutX             = $00000100; // fOutX:            1; XON/XOFF出力フロー制御
  dcb_InX              = $00000200; // fInX:             1;	XON/XOFF入力フロー制御
  dcb_ErrorChar        = $00000400; // fErrorChar:       1;	エラーによる置換を有効
  dcb_Null             = $00000800; // fNull:            1;	ヌル ストリッピングを有効
  dcb_Rts_Enable       = $00001000; // fRtsControl:      2;	RTSフロー制御	*/
  dcb_Rts_Handshake    = $00002000; //
  dcb_Rts_Toggle       = $00003000; //
  dcb_AbortOnError     = $00004000; // fAbortOnError:    1;	エラー時に読み取りまたは書き込みを中止
  dcb_Reserved         = $FFFF8000; // fDummy2:         17;	予約済み def mask $0008000 + $FFFF0000

//追加エラーコード

  CE_SENDTIMOEUT       = $20;       // 送信タイムアウトエラー
  CE_READTIMOEUT       = $40;       // 受信タイムアウトエラー

//ボーレート

  BRT_110     =    110;
  BRT_300     =    300;
  BRT_600     =    600;
  BRT_1200    =   1200;
  BRT_2400    =   2400;
  BRT_4800    =   4800;
  BRT_9600    =   9600;
  BRT_14400   =  14400;
  BRT_19200   =  19200;
  BRT_38400   =  38400;
  BRT_56000   =  56000;
  BRT_57600   =  57600;
  BRT_115200  = 115200;
  BRT_128000  = 128000;
  BRT_230400  = 230400;
  BRT_256000  = 256000;

// コメント

  Not_CommOpen  = '通信が開始されていません。';
  Over_Length   = '送信データ長が長すぎます。';
  ClCommErr     = 'ＲＳ２３２Ｃの状態取得できません、ポートエラー。';
  Timer_Error   = 'Break Check Timer Error';

type
  TWPRCCommBaudRated =
                (bps___110,bps___300,bps___600,bps__1200,bps__2400,bps__4800,bps__9600,bps_14400,
                 bps_19200,bps_38400,bps_56000,bps_57600,bps115200,bps128000,bps230400,bps256000,
                 User_BaudRate);
  TWPRCCommParityBits = (cpbNone, cpbOdd, cpbEven, cpbMark, cpbSpace);
  TWPRCCommByteSize = (cbs4, cbs5, cbs6, cbs7, cbs8);
  TWPRCCommStopBits = (csb1, csb15, csb2);
  TWPRCCommFlowControl = (cfcDtrDsr, cfcRtsCts, cfcXonXoff);
  TWPRCCommFlowControls = set of TWPRCCommFlowControl;
  TWPRCCommEvents = (evRxchar, evRxflag, evTxempty, evCts, evDsr, evRlsd, evBreak, evErr, evRing);
  TWPRCCommEventMask = set of TWPRCCommEvents;
  TWPRCCommErrCheck = (ShowOn, ShowOff);
  TWPRCCommEventChar = (Null, Ah, Dh, UserIn);
  TWPRCCommEvChrDoRev = (eventOff, eventOn);
  TWPRCCommWaitFor = (waitWrite, waitRead);
  TWPRCCommWaitFors = set of TWPRCCommWaitFor;
  TWPRCCommInterval = (_MAXDWORD,UserInTime);

  { 通信エラーのための例外処理クラス }
  ECommError = class(Exception);

  ECommOpenError = class(ECommError)
  private
    FErrorCode: Integer;
  public
    constructor Create(OpenErrorCode: Integer);
    property ErrorCode: Integer read FErrorCode;
  end;

  ECommReadWriteError = class(ECommError)
  private
    FErrorCode: DWord;
  public
    constructor Create(ReadWriteErrorCode: DWord);
    property ErrorCode: DWord read FErrorCode;
  end;


  { 通信イベントのためのメソッド型 }
  TWPRCCommNotifyEvent = procedure (Sender: TObject; EventMask: TWPRCCommEventMask) of object;
  TWPRCCommNotifyRxTxEvent = procedure (Sender: TObject; Size: DWord) of object;
  TWPRCCommNotifyErrEvent = procedure (Sender: TObject; ErrCode: DWord) of object;

  { 受信スレッドのクラス }
  TWPRCCommWatch = class(TThread)
  private
    FComDev   : THandle;                           // 通信デバイス・ハンドル
    FWPrcH    : HWND;
//    FOwner: TComponent;                         // 親コンポーネント(= TWPRCComm)
  protected
    procedure Execute; override;                // スレッドのメイン処理
  public
                                                // スレッドのコンストラクタ
    constructor Create(AWPrcH: HWND; ComDev: THandle);
  end;


  { 通信コンポーネントのクラス }
  TWPRCComm = class(TComponent)
  private
    FHandle         : THandle;                  // 通信デバイス・ハンドル
    FWPRCHandle     : HWND;                     // タイマー割り込みルーチンハンドル

    FDCB: TDCB;                                 // 通信デバイス制御ブロック
    FPort: Word;                                // 通信ポート番号
    FBaudRate: DWord;                           // 通信速度(bps)
    FBaudRated: TWPRCCommBaudRated;             // 通信速度(bps)選択

    FdwErrors: DWord;                           // エラーデーター

    FByteSize: TWPRCCommByteSize;               // データビット長
    FParityBits: TWPRCCommParityBits;           // パリティービット長
    FStopBits: TWPRCCommStopBits;               // ストップビット長
    FFlowControls: TWPRCCommFlowControls;       // フロー制御

    FInQueueSize: DWord;                        // 受信バッファーサイズ
    FOutQueueSize: DWord;                       // 送信バッファーサイズ
    FReceiveNotifySize: Word;                   // XOFF送信限界
    FSendNotifySize: Word;                      // XON送信限界
    FEventMask: TWPRCCommEventMask;             // 通信イベントマスク

    FReceiveThreshold: DWord;                   // 受信イベント発生文字数
    FOnCommEvent: TWPRCCommNotifyEvent;         // 通信イベントの発生
    FOnCommReceive: TWPRCCommNotifyRxTxEvent;   // 受信イベント
    FOnCommTransmit: TWPRCCommNotifyRxTxEvent;  // 送信イベント
    FOnCommErrEvent: TWPRCCommNotifyErrEvent;   // エラーイベント

    FReadOs: TOverlapped;                       // 受信用オーバーラップ構造体
    FWriteOs: TOverlapped;                      // 送信用オーバーラップ構造体

    FThread: TWPRCCommWatch;                    // 受信イベント監視スレッド
    FSeterr: Integer;                           // ポート設定フラグ　エラー －１
    FErrCheck : TWPRCCommErrCheck;              // 入力エラーチェック
    FEventFlagIn: AnsiChar;                     // 受信割り込み発生指定文字
    FEventFlag : TWPRCCommEventChar;            // 受信割り込み発生文字選択
    FEvChrDoRev : TWPRCCommEvChrDoRev;          // 受信割り込み発生文字による受信処理

    FBreakSendTime: DWord;                      // ブレーク送信時間
    FSendTimeOut: DWord;                        // 送信タイムアウト時間
    FSendMultiplier: DWord;                     // １バイト送信時間
    FReceiveIntervals: TWPRCCommInterval;       // 受信バイト間のタイムアウト時間選択
    FReadIntervalTimeout: DWord;                // 受信バイト間のタイムアウト時間
    FReceiveTimeOut: DWord;                     // 受信タイムアウト時間
    FReceiveMultiplier: DWord;                  // １バイト受信時間
    FCommWaitFors : TWPRCCommWaitFors;          // 送受信終了Wait For
    FReadWait: boolean;                         // 受信終了Wait For
    FWriteWait: boolean;                        // 送信終了Wait For

    FInterval: Cardinal;                        // ブレーク検出用タイマー usb->rs232c の場合
    FWindowHandle: HWND;                        // タイマー割り込みルーチンハンドル
    FEnabled: Boolean;                          // タイマーフラグ
    FSetEvnt: Cardinal;                         // イべントフラグ
    FCE_FRAME:Boolean;                          // フレームエラーフラグ

    Fdcb_Dtr_Enable:Boolean;                    // dcb_Dtr_Enable フラグ

    procedure SetBaudRate(Value: DWord);                      // ボーレート自由せってい
    procedure SetBaudRated;                                   // ボーレート既定値選択

    procedure SetParityBits(Value: TWPRCCommParityBits);       // パリティ選択
    procedure SetByteSize(Value: TWPRCCommByteSize);           // データービット数
    procedure SetStopBits(Value: TWPRCCommStopBits);           // ストップビット選択
    procedure SetFlowControls(Value: TWPRCCommFlowControls);   // フローコントロール
    procedure SetReceiveNotifySize(Value: Word);              // XOFF送信限界
    procedure SetSendNotifySize(Value: Word);                 // XON送信限界
    procedure SetEventMask(Value: TWPRCCommEventMask);         // 割り込みマスク設定
    procedure SeTWPRCCommWaitFors;                             // 送受信終了Waitの設定

    procedure SetEventCharIn(Value: AnsiChar);                    // 受信割り込み自由設定文字
    procedure SetEventChar;                                   // 受信割り込み文字選択
    procedure SetReceiveIntervals;                            // 受信バイト間のタイムアウト時間選択
    procedure SetFWriteReadTimeout;                           // 受信バイト間のタイムアウト時間
    function GetDsrState: Boolean;                            // Dsr確認
    function GetOpenCheck: Boolean;                           // COMM Open確認
    function GetRemainSize: Cardinal;                         // 送信バッファ残り容量調査
    function GetSendSpace: Cardinal;                          // 送信バッファ空き容量調査
    function GetReceiveSize: Cardinal;                        // 受信バッファ受信容量調査

    procedure UpdateTimer;                                    // タイマーセットルーチン
    procedure SetInterval(Value: Cardinal);                   // タイマーインターバル時間セット
    procedure SetEnabled(Value: Boolean);                     // タイマーのスタートストップ
  protected
    procedure WndProc(var Msg: TMessage);                     // タイマーによる呼び出しルーチン
    procedure WndProcComm(var Msg: TMessage);                 // WaitCommEvent 呼び出しルーチン
    procedure DoCommEvent(EvtMask: DWord); virtual;           // 送受信割り込み処理
    procedure DoCommReceive; virtual;                         // 文字受信割り込み処理
    procedure DoCommTransmit; virtual;                        // 送信バッファ 空きイベント処理
    procedure DoCommErrEvent; virtual;                        // エラー割り込み処理
    procedure DoCommEventChar; virtual;                       // イベント文字による割り込み処理
  public
    constructor Create(AOwner: TComponent); override;         // Comm通信の作成
    destructor Destroy; override;                             // Comm通信の破棄
    procedure Open;                                           // Comm通信の開始
    procedure Close;                                          // Comm通信の終了
    procedure Write(const Buffer; Size: DWord);             // 送信文字書き込み
    procedure Read(Buffer: PAnsiChar; Size: DWord);             // 受信文字読み出し
    procedure SendString(S: AnsiString);                          // 文字送信
    procedure SendBreak;                                      // ブレーク送信
    procedure TransmitChar(OneChar: AnsiChar; ResultBool: PBoolean);  // 一文字直接送信 遅い
    property Handle: THandle read FHandle;                    // 通信コンポーネントハンドル
    property DsrState: Boolean read GetDsrState;              // DSR信号取得
    property OpenCheck: Boolean read GetOpenCheck;            // ポートオープン状態取得
    property RemainSize: Cardinal read GetRemainSize;         // 送信残りサイズ取得
    property SendSpace: Cardinal read GetSendSpace;           // 空き容量取得
    property ReceiveSize: Cardinal read GetReceiveSize;       // 受信サイズ取得
  published
    property Port: Word read FPort write FPort
                default 1;
    property BaudRate: DWord read FBaudRate write SetBaudRate
                default 9600;
    property BaudRated: TWPRCCommBaudRated read FBaudRated write FBaudRated
                default User_BaudRate;
    property ParityBits: TWPRCCommParityBits read FParityBits write SetParityBits
                default cpbNone;
    property ByteSize: TWPRCCommByteSize read FByteSize write SetByteSize
                default cbs8;
    property StopBits: TWPRCCommStopBits read FStopBits write SetStopBits
                default csb1;
    property FlowControls: TWPRCCommFlowControls read FFlowControls write SetFlowControls
                default [cfcRtsCts];
    property ReceiveThreshold: DWord read FReceiveThreshold write FReceiveThreshold
                default 1;
    property InQueueSize: DWord read FInQueueSize write FInQueueSize
                default 4096;
    property OutQueueSize: DWord read FOutQueueSize write FOutQueueSize
                default 4096;
    property ReceiveNotifySize: Word read FReceiveNotifySize write SetReceiveNotifySize
                default 3072;
    property SendNotifySize: Word read FSendNotifySize write SetSendNotifySize
                default 1024;
    property EventMask: TWPRCCommEventMask read FEventMask write SetEventMask
                default [];
    property EventFlagIn: AnsiChar read FEventFlagIn write SetEventCharIn
                default #0;
    property EventFlag: TWPRCCommEventChar read FEventFlag write FEventFlag
                default Null;
    property RxflagReceive: TWPRCCommEvChrDoRev read FEvChrDoRev write FEvChrDoRev
                default eventOff;
    property ReadErrShow: TWPRCCommErrCheck read FErrCheck write FErrCheck
                default ShowOff;
    Property BreakSendTime: Cardinal read FBreakSendTime write FBreakSendTime
                default 500;
    Property SendTimeOut: DWord read FSendTimeOut write FSendTimeOut
                default 1000;
    Property SendMultiplier: DWord read FSendMultiplier write FSendMultiplier
                default 0;
    Property ReceiveIntervals: TWPRCCommInterval read FReceiveIntervals write FReceiveIntervals
                default _MAXDWORD;
    Property ReceiveInterval: DWord read FReadIntervalTimeout write FReadIntervalTimeout
                default 1000;
    Property ReceiveTimeOut: DWord read FReceiveTimeOut write FReceiveTimeOut
                default 1000;
    Property ReceiveMultiplier: DWord read FReceiveMultiplier write FReceiveMultiplier
                default 0;
    property CommWaitFors: TWPRCCommWaitFors read FCommWaitFors write FCommWaitFors
                default [waitWrite, waitRead];

    property OnCommEvent: TWPRCCommNotifyEvent read FOnCommEvent write FOnCommEvent;
    property OnCommReceive: TWPRCCommNotifyRxTxEvent read FOnCommReceive write FOnCommReceive;
    property OnCommTransmit: TWPRCCommNotifyRxTxEvent read FOnCommTransmit write FOnCommTransmit;
    property OnCommErrEvent: TWPRCCommNotifyErrEvent read FOnCommErrEvent write FOnCommErrEvent;
  end;

procedure Register;

implementation

procedure TWPRCComm.WndProc(var Msg: TMessage);           // USB->RS232C ブレークタイミング遅れの場合の処理
var
  dwErrors: DWord;
  Stat: TComStat;
const
  notCE_BREAK = MAXDWORD - CE_BREAK - CE_FRAME;
begin
  with Msg do
    if Msg = WM_TIMER then                                // ブレーク検出用タイマー割り込みだったら
      try
        SetEnabled(False);                                // タイマー停止
        if not ClearCommError(FHandle, dwErrors, @Stat) then exit; // エラー及びバッファ受信サイズ取得
        if dwErrors and CE_BREAK = CE_BREAK then          // エラーにブレークがあったら
          begin
            FCE_FRAME := False;                           // ブレークだったらフレームエラー取り消し
            if FSetEvnt and EV_BREAK = EV_BREAK then      // ブレークマスクがセットされていたら
              begin
                dwErrors := dwErrors and notCE_BREAK;     // ブレーク,フレームフラグ消去
                DoCommEvent(EV_BREAK);                    // ブレーク割り込み発生
              end;
          end;
        if FCE_FRAME then                                 // フレームエラーフラグ セットされていたら
          begin
            FCE_FRAME := False;                           // フレームエラーフラグ リセット
            dwErrors := dwErrors or CE_FRAME;             // エラーフラグにフレームエラー追加
          end;
        if (FSetEvnt and EV_ERR = EV_ERR) and (dwErrors <> 0) then  // エラー割り込みが設定されていたら
          begin
            FdwErrors := dwErrors;                        // エラー処理用フラグに保存
            DoCommErrEvent;                               // 受信エラーの場合エラー割り込み発生
          end;
      except
        Application.HandleException(Self);                // 例外処理
      end
    else
      Result := DefWindowProc(FWindowHandle, Msg, wParam, lParam);   //デフォルトのウィンドウ プロシージャを呼び出します
end;

procedure TWPRCComm.UpdateTimer;                           // タイマーの設定
begin
  KillTimer(FWindowHandle, 1);                               // タイマー停止
  if (FInterval <> 0) and FEnabled then                      // タイマーが設定されていたら
    if SetTimer(FWindowHandle, 1, FInterval, nil) = 0 then   // 標準タイマーの設定スタート
      raise EOutOfResources.Create(Timer_Error);             // タイマーが設定できなかったら
end;

procedure TWPRCComm.SetEnabled(Value: Boolean);            // タイマーのスタート、ストップ
begin
  if Value <> FEnabled then
  begin
    FEnabled := Value;
    UpdateTimer;
  end;
end;

procedure TWPRCComm.SetInterval(Value: Cardinal);          // タイマーインターバル時間設定
begin
  if Value <> FInterval then
  begin
    FInterval := Value;
    UpdateTimer;
  end;
end;

{ オブジェクトの生成 }
constructor TWPRCComm.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  // 初期値の設定
  FSeterr := -1;                                  // 通信デバイス・ハンドル
  FPort := 1;                                     // 通信ポート
  FBaudRate := 9600;                              // 通信速度
  FBaudRated := User_BaudRate;                    // 通信速度選択
  FByteSize := cbs8;                              // データビット長
  FParityBits := cpbNone;                         // パリティービット長
  FStopBits := csb1;                              // ストップビット長
  FFlowControls := [cfcRtsCts];                   // フロー制御
  FReceiveThreshold := 1;                         // 受信イベント発生文字数
  FInQueueSize := 4096;                           // 受信バッファー長
  FOutQueueSize := 4096;                          // 送信バッファー長
  FReceiveNotifySize := 3072;                     // XOFF送信限界
  FSendNotifySize := 1024;                        // XON送信限界
  FEventMask := [evRxchar];                       // イベントマスク
  FEventFlagIn := #0;                             // Userイベント文字
  FEventFlag := Null;                             // イベント文字指定
  FEvChrDoRev := eventOff;                        // イベント文字による受信処理フラグ
  FCommWaitFors := [waitWrite, waitRead];         // 送受信終了WaitFor
  FDCB.DCBLength := SizeOf(FDCB);                 // デバイス制御ブロック長の設定
  FBreakSendTime := 500;                          // ブレーク時間
  FSendTimeOut := 1000;                           // 送信タイムアウト
  FSendMultiplier := 0;                           // １バイト送信時間
  FReceiveIntervals := _MAXDWORD;                 // 受信ﾊﾞｲﾄ間のﾀｲﾑｱｳﾄ時間MaxWord選択
  FReadIntervalTimeout := 1000;                   // 受信ﾊﾞｲﾄ間のﾀｲﾑｱｳﾄ時間
  FReceiveTimeOut := 1000;                        // 受信タイムアウト
  FReceiveMultiplier:= 0;                         // １バイト受信時間
  FErrCheck := ShowOff;                           // エラーチェック
                                                  // エラーチェックは、デバッグ時のみ使用し
                                                  // 通常は使用しない。
                                                  // 受信毎にエラーチェックが掛かるため、
                                                  // エラーの洪水となります。
  FEnabled := False;                              // タイマーフラグ
  FInterval := 50;                                // タイマー時間
  FCE_FRAME := False;                             // フレームエラーフラグ
  FWindowHandle := Classes.AllocateHWnd(WndProc); // タイマー呼び出しルーチンハンドル取得
  FWPRCHandle   := Classes.AllocateHWnd(WndProcComm);   // WaitCommEvent 呼び出しルーチンハンドル取得
end;

{ オブジェクトの破棄 }
destructor TWPRCComm.Destroy;
begin
  if FSeterr >= 0 then Close;                     // 通信中ならクローズする
  FEnabled := False;                              // タイマー停止フラグセット
  UpdateTimer;                                    // タイマーの停止
  Classes.DeallocateHWnd(FWPRCHandle);            // WndProc の破棄
  Classes.DeallocateHWnd(FWindowHandle);          // WndProc の破棄
  inherited Destroy;                              // 破棄
end;

{----- プロパティ関連関数群 ----------------------------------------}

{ 通信速度の設定 }
procedure TWPRCComm.SetBaudRate(Value: DWord);
begin
  FBaudRate := Value;                             // ユーザー設定値 内部変数に保存
  if FSeterr >= 0 then                            // 通信がオープンされていたら
  begin
    GetCommState(FHandle, FDCB);                  // 現在のTDCBの取得
    FDCB.BaudRate := FBaudRate;                   // 新しいボーレートの設定
    SetCommState(FHandle, FDCB);                  // 新しいTDCBをセット
  end;
end;

{ 通信速度の選択設定 [プロパティでの選択値に設定する]}
procedure TWPRCComm.SetBaudRated;
begin
  if User_BaudRate = FBaudRated then exit;        // User_BaudRateだったら設定終了し
                                                  // ユーザー設定値を使用
  if bps___110 = FBaudRated then FBaudRate := BRT_110;
  if bps___300 = FBaudRated then FBaudRate := BRT_300;
  if bps___600 = FBaudRated then FBaudRate := BRT_600;
  if bps__1200 = FBaudRated then FBaudRate := BRT_1200;
  if bps__2400 = FBaudRated then FBaudRate := BRT_2400;
  if bps__4800 = FBaudRated then FBaudRate := BRT_4800;
  if bps__9600 = FBaudRated then FBaudRate := BRT_9600;
  if bps_14400 = FBaudRated then FBaudRate := BRT_14400;
  if bps_19200 = FBaudRated then FBaudRate := BRT_19200;
  if bps_38400 = FBaudRated then FBaudRate := BRT_38400;
  if bps_56000 = FBaudRated then FBaudRate := BRT_56000;
  if bps_57600 = FBaudRated then FBaudRate := BRT_57600;
  if bps115200 = FBaudRated then FBaudRate := BRT_115200;
  if bps128000 = FBaudRated then FBaudRate := BRT_128000;
  if bps230400 = FBaudRated then FBaudRate := BRT_230400;
  if bps256000 = FBaudRated then FBaudRate := BRT_256000;
end;

{ 受信バイト間のタイムアウト時間入力処理}
procedure TWPRCComm.SetFWriteReadTimeout;
var
  CommTimeouts: TCommTimeouts;                    // タイムアウト構造体
begin
  if FSeterr >= 0 then                            // 通信がオープンされていたら
    begin
      CommTimeouts.ReadIntervalTimeout := FReadIntervalTimeout;       // バイト受信間隔時間
      CommTimeouts.ReadTotalTimeoutMultiplier := FReceiveMultiplier;  // １バイト受信時間
      CommTimeouts.ReadTotalTimeoutConstant := FReceiveTimeOut;       // 受信時間固定部分
      CommTimeouts.WriteTotalTimeoutMultiplier := FSendMultiplier;    // １バイト送信時間
      CommTimeouts.WriteTotalTimeoutConstant := FSendTimeOut;         // 送信時間固定部分
      SetCommTimeouts(FHandle, CommTimeouts);                         // タイムアウト設定
    end;
end;

{ 受信バイト間のタイムアウト時間選択入力処理}
procedure TWPRCComm.SetReceiveIntervals;
begin
  if UserInTime = FReceiveIntervals then exit;    // ユーザー入力指定なら終了
  if _MAXDWORD = FReceiveIntervals then FReadIntervalTimeout := MAXDWORD;  // 最大値に設定
end;

{イベント発生文字の設定}
procedure TWPRCComm.SetEventCharIn(Value: AnsiChar);
begin
  FEventFlagIn := Value;                          // 内部変数に保存
  if FSeterr >= 0 then                            // 通信がオープンされていたら
    begin
      GetCommState(FHandle, FDCB);                // 現在のTDCBの取得
      FDCB.EvtChar := FEventFlagIn;               // イベント発生文字設定
      SetCommState(FHandle, FDCB);                // 新しいTDCBをセット
    end;
end;

{イベント発生文字の設定方法選択}
procedure TWPRCComm.SetEventChar;
begin
  if UserIn = FEventFlag then exit;               // ユーザー入力指定なら終了
  if Ah = FEventFlag then FEventFlagIn := #10;    // 改行指定
  if Dh = FEventFlag then FEventFlagIn := #13;    // 復帰指定
  if Null = FEventFlag then FEventFlagIn := #0;   // ヌル指定
end;

{ 送受信するバイトデータのビット数の設定 }
procedure TWPRCComm.SetByteSize(Value: TWPRCCommByteSize);
begin
  FByteSize := Value;                             // 内部変数に保存
  if FSeterr >= 0 then                            // 通信がオープンされていたら
    begin
      GetCommState(FHandle, FDCB);                // 現在のTDCBの取得
      FDCB.ByteSize := 4 + Ord(FByteSize);        // 順序数に４を足して４から８に
      SetCommState(FHandle, FDCB);                // 新しいTDCBをセット
    end;
end;

{ パリティービット数の設定 }
procedure TWPRCComm.SetParityBits(Value: TWPRCCommParityBits);
begin
  FParityBits := Value;                           // 内部変数に保存
  if FSeterr >= 0 then                            // 通信がオープンされていたら
    begin
      GetCommState(FHandle, FDCB);                // 現在のTDCBの取得
      FDCB.Parity := Ord(FParityBits);            // 順序数をそのまま設定
      SetCommState(FHandle, FDCB);                // 新しいTDCBをセット
    end;
end;

{ ストップビット数の設定 }
procedure TWPRCComm.SetStopBits(Value: TWPRCCommStopBits);
begin
  FStopBits := Value;                             // 内部変数に保存
  if FSeterr >= 0 then                            // 通信がオープンされていたら
    begin
      GetCommState(FHandle, FDCB);                // 現在のTDCBの取得
      FDCB.StopBits := Ord(FStopBits);            // 順序数をそのまま設定
      SetCommState(FHandle, FDCB);                // 新しいTDCBをセット
    end;
end;

{ フロー制御方式の設定 }
procedure TWPRCComm.SetFlowControls(Value: TWPRCCommFlowControls);
begin
  FFlowControls := Value;                     // 内部変数に保存
  if FSeterr >= 0 then                        // 通信がオープンされていたら
  begin
    GetCommState(FHandle, FDCB);
    FDCB.Flags := FDCB.Flags and dcb_Reserved;// fBinary:1              ﾊﾞｲﾅﾘｰ ﾓｰﾄﾞ EOF ﾁｪｯｸ無し
                                              // fParity:1              ﾊﾟﾘﾃｨﾁｪｯｸ
                                              // fOutxCtsFlow:1         CTS出力フロー制御
                                              // fOutxDsrFlow:1         DSR出力フロー制御
                                              // fDtrControl:2          DTRフロー制御の種類
                                              // fDsrSensitivity:1      True時DSR信号のOFFで受信無視
                                              // fTXContinueOnXoff:1    XOFF後も送信継続
                                              // fOutX:1, fInX:1        XON/OFF出力入力フロー制御
                                              // fErrorChar:1           エラーによる文字置換
                                              // fNull:1                ヌルストリッピング
                                              // fRtsControl:2          RTSフロー制御
                                              // fAbortOnError:1        エラー時読み取り書き込み中止
                                              // をオフにする
                                              // fDummy2:17             Reserved  FFFF8*** そのまま

    if cfcRtsCts in FFlowControls then        // RTS/CTSフロー制御の場合
      FDCB.Flags := FDCB.Flags or dcb_OutxCtsFlow or
                    dcb_Rts_Handshake
    else
      FDCB.Flags := FDCB.Flags or dcb_Rts_Enable;

    if cfcDtrDsr in FFlowControls then        // DTR/DSRフロー制御の場合
      begin
        FDCB.Flags := FDCB.Flags or dcb_OutxDsrFlow or
                    dcb_Dtr_Handshake;
        Fdcb_Dtr_Enable := False;
      end
      else
      begin
        FDCB.Flags := FDCB.Flags or dcb_Dtr_Enable;
        Fdcb_Dtr_Enable := True;
      end;
    if cfcXonXoff in FFlowControls then       // XON/XOFFフロー制御の場合
      FDCB.Flags := FDCB.Flags or dcb_OutX or dcb_InX;
    FDCB.XonChar := Char(ASCII_XON);          // XON Charのセット
    FDCB.XoffChar := Char(ASCII_XOFF);        // Xoff Charのセット

    FDCB.Flags := FDCB.Flags or dcb_Binary or dcb_Parity;   // fBinary & fParity
                                                            // 常時ﾊﾞｲﾅﾘｰ、EOFﾁｪﾂｸ無し
                                                            // 常時ﾊﾟﾘﾃｨﾁｪｯｸOn
    SetCommState(FHandle, FDCB);              // 新しいTDCBのセット
  end;
end;

{ 受信バッファの通知サイズの設定 }
procedure TWPRCComm.SetReceiveNotifySize(Value: Word);
begin
  FReceiveNotifySize := Value;                // 内部変数に保存
  if FSeterr >= 0 then                        // 通信がオープンされているなら
    begin
      GetCommState(FHandle, FDCB);            // 現在のTDCBの取得
      FDCB.XoffLim := FInQueueSize - FReceiveNotifySize;
      SetCommState(FHandle, FDCB);            // 新しいTDCBのセット
    end;
end;

{ 送信バッファの通知サイズの設定 }
procedure TWPRCComm.SetSendNotifySize(Value: Word);
begin
  FSendNotifySize := Value;                   // 内部変数に保存
  if FSeterr >= 0 then                        // 通信がオープンされているなら
    begin
      GetCommState(FHandle, FDCB);            // 現在のTDCBの取得
      FDCB.XonLim := FSendNotifySize;         // 新しい値の設定
      SetCommState(FHandle, FDCB);            // 新しいTDCBのセット
    end;
end;

{ 通信イベントマスクの設定 }
procedure TWPRCComm.SetEventMask(Value: TWPRCCommEventMask);
var
  dwEvtMask: DWORD;                           // イベントマスク
begin
  FEventMask := Value;                        // 内部変数に保存
  if FSeterr >= 0 then                        // 通信がオープンされているなら
    begin
      dwEvtMask := 0;                         // イベントマスクを初期化
      if evRxchar in FEventMask then          // 文字受信イベント
        dwEvtMask := dwEvtMask or EV_RXCHAR;
      if evRxflag in FEventMask then          // イベント文字の受信
        dwEvtMask := dwEvtMask or EV_RXFLAG;
      if evTxempty in FEventMask then         // 送信バッファが空
        dwEvtMask := dwEvtMask or EV_TXEMPTY;
      if evCts in FEventMask then             // CTS信号の変化
        dwEvtMask := dwEvtMask or EV_CTS;
      if evDsr in FEventMask then             // DSR信号の変化
        dwEvtMask := dwEvtMask or EV_DSR;
      if evRlsd in FEventMask then            // RLSD(CD)信号の変化
        dwEvtMask := dwEvtMask or EV_RLSD;
      if evBreak in FEventMask then           // ブレークの検出
        dwEvtMask := dwEvtMask or EV_BREAK;
      if evErr in FEventMask then             // 回線状態エラー
        dwEvtMask := dwEvtMask or EV_ERR;
      if evRing in FEventMask then            // 電話のベルが鳴る
        dwEvtMask := dwEvtMask or EV_RING;

      SetCommMask(FHandle, dwEvtMask);        // 通信イベントマスクの設定
      FSetEvnt := dwEvtMask;
  end;
end;

{ 送受信Read Writeの 実行終了待ちの設定 }
procedure TWPRCComm.SeTWPRCCommWaitFors;
begin
  FReadWait  := False;
  FWriteWait := False;
  if waitRead in FCommWaitFors  then FReadWait := True; // 受信終了Wait For
  if waitWrite in FCommWaitFors then FWriteWait:= True; // 送信終了Wait For
end;

{-----  DSR信号の状況を取得する ----------------------------------}

{ True: DSR ON,   False: DSR OFF }
function TWPRCComm.GetDsrState: Boolean;
var
  ModemStat: DWORD;
begin
  if FSeterr >= 0 then                            // 通信がオープンされていたら
    begin
      GetCommModemStatus(FHandle, ModemStat);     // モデムステータスの取得
      Result := ((ModemStat and MS_DSR_ON) = MS_DSR_ON);
    end
    else
      Result := False;
end;

{----- 通信イベント発生群 ----------------------------------------}

{ 通信イベント発生 (データ受信、送信バッファ空き、イベント文字受信と回線状態エラーは除く)}
procedure TWPRCComm.DoCommEvent(EvtMask: DWord);
var
  EventMask: TWPRCCommEventMask;                   // TWPRCCommイベントマスク集合型
begin
  //通信中でOnCommEventが設定されている場合
  if (FSeterr >= 0) and Assigned(FOnCommEvent)  then
    begin
      EventMask := [];                                  // イベントマスク集合体の初期化
{
      if (EvtMask and EV_RXCHAR)  = EV_RXCHAR   then // EV_RXCHAR  文字受信
        EventMask := EventMask + [evRxchar];
      if (EvtMask and EV_TXEMPTY) = EV_TXEMPTY  then // EV_TXEMPTY 送信バッファから
        EventMask := EventMask + [evTxempty];
      if (EvtMask and EV_ERR)     = EV_ERR      then // EV_ERR      回線状態エラー
        EventMask := EventMask + [evErr];
      if (EvtMask and EV_RXFLAG) = EV_RXFLAG    then // EV_RXFLAG  イベント文字受信
        EventMask := EventMask + [evRxFlag];
}
      if (EvtMask and EV_BREAK)   = EV_BREAK    then    // EV_BREAK   ブレーク信号受信
        EventMask := EventMask + [evBreak];
      if (EvtMask and EV_CTS  )   = EV_CTS      then    // EV_CTS     CTS信号の変化
        EventMask := EventMask + [evCts];
      if (EvtMask and EV_DSR  )   = EV_DSR      then    // EV_DSR     DSR信号の変化
        EventMask := EventMask + [evDsr];
      if (EvtMask and EV_RING )   = EV_RING     then    // EV_RING    RI信号検知 電話のベルがなる
        EventMask := EventMask + [evRing];
      if (EvtMask and EV_RLSD )   = EV_RLSD     then    // EV_RLSD    RLSD信号の変化
        EventMask := EventMask + [evRlsd];

      FOnCommEvent(self, EventMask);              //イベントの発生
    end;
end;

{ データ受信イベント発生 }
procedure TWPRCComm.DoCommReceive;                 //* 割り込み発生の受信文字数の設定を、1 以上に
var                                               //  変更してはいけない。(FReceiveThreshold)
  dwErrors: DWord;                                //  受信データーが固定長の場合でも、処理は、
  Stat: TComStat;                                 //  アプリ側で行わないと、読みこぼしの問題が
begin                                             //  が発生します。
  if (FSeterr >= 0) and Assigned(FOnCommReceive) then   // 割り込みルーチン設定されているなら
    begin
      if not ClearCommError(FHandle, dwErrors, @Stat) then    // エラー及びバッファ受信サイズ取得
                        raise ECommError.Create(ClCommErr);   // エラー表示
      if Stat.cbInQue >= FReceiveThreshold then   // 受信文字数がFReceiveThresholdと等しいか以上なら
          FOnCommReceive(Self, Stat.cbInQue);     // 受信イベント発生  Stat.cbInQue 受信文字数
    end;                                          // FReceiveThresholdが0ではいけない、複数文字受信
end;                                              // すると、全文字読み出しても読み出し後文字数０で
                                                  // 割り込みが発生します
{ 送信バッファ空きイベント発生 }
procedure TWPRCComm.DoCommTransmit;
var
  dwErrors: DWord;                                  // エラー取得用
  Stat: TComStat;                                   // COMSTAT構造体
begin
  if (FSeterr >= 0) and Assigned(FOnCommTransmit) then  // 割り込みルーチン設定されているなら
    begin
      if not ClearCommError(FHandle, dwErrors, @Stat) then  // エラー及びバッファ送信空サイズ取得
                      raise ECommError.Create(ClCommErr);   // エラー表示
      FOnCommTransmit(Self, Stat.cbOutQue);         // 空きイベント発生 Stat.cbOutQue 送信文字数
    end;
end;

{EV_RXFLAG(イベント発生文字)処理}
procedure TWPRCComm.DoCommEventChar;
begin
  if FEvChrDoRev = eventOn then DoCommReceive          // データ受信イベント発生
                           else DoCommEvent(EV_RXFLAG);// evntOffなら一般イベント
end;

{EV_ERRによるエラー表示}
procedure TWPRCComm.DoCommErrEvent;
begin
  if FSeterr >= 0 then                                     // 通信がオープンされていたら
    begin
      if FdwErrors <> 0 then                               // エラーが有るなら
        begin
          if (FErrCheck = ShowOn) then                     // ShowOnなら
              raise ECommReadWriteError.Create(FdwErrors)  // エラー表示
            else                                           // ShowOff で
              if Assigned(FOnCommErrEvent) then            // 割り込みルーチン設定されているなら
                FOnCommErrEvent(Self, FdwErrors);          // エラーイベント発生
        end;
    end;
end;

{----- 通信本体関数群 ----------------------------------------------}

{ 通信ポートのオープン }
procedure TWPRCComm.Open;
var
  szport: string;                             // ポート名 UNICODE
begin                                         // タイムアウト時間設定 入力ミスならエラー表示終了
  if FSeterr < 0 then
    begin                                     // 通信中でない時
// Initialize the rest of the OVERLAPPED structure to zero.
      FReadOs.Offset := 0;                    // 受信オーバーラップ処理用
      FReadOs.OffsetHigh := 0;
      FReadOs.Internal := 0;
      FReadOs.InternalHigh := 0;
                                              // イベントオブジェクトの作成
      FReadOs.hEvent := CreateEvent(nil,      // ハンドルを継承しない
                                    True,     // 手動リセットイベント
                                    False,    // 非シグナル状態で初期化
                                    nil);     // イベントオブジェクトの名前無し
      if FReadOs.hEvent = 0 then
        raise ECommOpenError.Create(-2);      // 受信イベントが作成できない

// Initialize the rest of the OVERLAPPED structure to zero.
      FWriteOs.Offset := 0;                   // 送信オーバーラップ処理用
      FWriteOs.OffsetHigh := 0;
      FWriteOs.Internal := 0;
      FWriteOs.InternalHigh := 0;

      FWriteOs.hEvent := CreateEvent(nil,     // ハンドルを継承しない
                                    True,     // 手動リセットイベント
                                    False,    // 非シグナル状態で初期化
                                    nil);     // イベントオブジェクトの名前無し
      if FWriteOs.hEvent = 0 then
        begin
          CloseHandle(FReadOs.hEvent);        // 受信用イベントのクローズ
          raise ECommOpenError.Create(-3);    // 送信イベントが作成できない
        end;


// winNT,Win2000,WinXPではCOM1～256 を使用できるが　COM9以上はCreateFileWを使用する必要があります。
// CreateFileは、文字長さ4文字制限(COMx)で使用できません。
// CreateFileW は Win32s,Win9X,WinMeでは使用できません Win32s,Win9X,WinMe では、COM1～9。

      try
        szPort := '\\?\COM'+ IntToStr(FPort) + #0;   // ポート名 長さチェック無し
        FSeterr := CreateFileW(PWidechar(szPort),
                          GENERIC_READ or GENERIC_WRITE,
                          0,                          // 排他的使用(*)
                          nil,                        // セキュリティー属性なし
                          OPEN_EXISTING,              // 既存(*)
                          FILE_ATTRIBUTE_NORMAL or    // 通常
                          FILE_FLAG_OVERLAPPED,       // オーバーラップ入出力
                          0);                         // テンプレートなし(*)
      except
        CloseHandle(FReadOs.hEvent);                  // 受信用イベントのクローズ
        CloseHandle(FWriteOs.hEvent);                 // 送信用イベントのクローズ
      end;
    if FSeterr < 0 then                               // エラー発生時の例外処理  try except で
      raise ECommOpenError.Create(FSeterr);           // 例外処理しないので此処で処理します
                                                      // 例外時これよ下の行は実行されません
    if FSeterr >= 0  then FHandle := FSeterr;         // Fileの設定が出来たらハンドル値をコピー設定
    // 送受信バッファーサイズの設定
    SetupComm(FHandle, FInQueueSize, FOutQueueSize);  // 送受信バッファ設定

    // すべてのバッファー情報を破棄する
    PurgeComm(FHandle, PURGE_TXABORT or               // バッファ情報クリア
                       PURGE_RXABORT or
                       PURGE_TXCLEAR or
                       PURGE_RXCLEAR);

    // タイムアウトのセットアップ
    SetReceiveIntervals;                              // 受信インターバル選択
    SetFWriteReadTimeout;                             // 全タイムの設定

    // 通信環境の設定
    SetBaudRated;                                     // User指定通信速度選択
    SetBaudRate(FBaudRate);                           // 通信速度
    SetByteSize(FByteSize);                           // データビット数
    SetParityBits(FParityBits);                       // パリティービット数
    SetStopBits(FStopBits);                           // ストップビット数

    SetFlowControls(FFlowControls);                   // フロー制御
    SetReceiveNotifySize(FReceiveNotifySize);         // XOFF送信限界
    SetSendNotifySize(FSendNotifySize);               // XOn送信限界

    SetEventMask(FEventMask);                         // イベントマスク
    SetEventChar;                                     // イベント発生受信文字選択
    SetEventCharIn(FEventFlagIn);                     // イベント発生受信文字設定

    SeTWPRCCommWaitFors;                              // 送受信実行終了待ちの設定

    FThread := TWPRCCommWatch.Create(FWPRCHandle, FHandle);   // 受信監視スレッドの起動

    FInterval := 1000 * 11 * 10 div FBaudRate;        // エラーブレーク確認遅延タイマー値 約10バイトの時間
    if FInterval < 50 then FInterval := 50;           // 50msec以下だったら50msecにセット 15以下では Break 不検出
    FEnabled := False;                                // タイマーフラグ
    SetInterval(FInterval);                           // タイマー時間セット
    FCE_FRAME := False;                               // フレームエラーフラグ
    if Fdcb_Dtr_Enable then EscapeCommFunction(FHandle, SETDTR);  // DTRをオンにします
                                                      // 実際には無くても通常はONになります。
  end;
end;

{ 通信ポートのクローズ }
procedure TWPRCComm.Close;
var
  dwErrors: DWord;                                    // エラー取得用
  Stat: TComStat;                                     // COMSTAT構造体
begin
  if FSeterr >= 0 then
  begin
    ClearCommError(FHandle, dwErrors, @Stat);         // エラー取得
    if Fdcb_Dtr_Enable then EscapeCommFunction(FHandle, CLRDTR);   // DTRをオフにする
    FThread.Terminate;                                // スレッドを終了通知を出す
    SetCommMask(FHandle, 0);                // 通知イベントを再設定クリアしてスレッドを終了
                                            // させる、WaiTWPRCCommEventで停止しているが、
                                            // SeTWPRCCommMask で Event が発生しEvent処理が行われます。

// FreeOnTerminateでスレッドを終了するため下記の２行は使用しない。
{
    FThread.WaitFor;                        // スレッドの終了を待つ      CloseHandle迄ｽﾚｯﾄﾞ終了
    FThread.Free;                           // スレッドを破棄する        しないので注意
}

    // すべてのバッファー情報を破棄する
    PurgeComm(FHandle, PURGE_TXABORT or     // バッファ情報クリア
                       PURGE_RXABORT or
                       PURGE_TXCLEAR or
                       PURGE_RXCLEAR);

    CloseHandle(FHandle);                   // シリアル通信のクローズ
    FSeterr := -1;                          // 再度オープンする為 -1 にする

    SetEnabled(False);                      // タイマー停止
    CloseHandle(FReadOs.hEvent);            // 受信イベントのクローズ
    Closehandle(FWriteOs.hEvent);           // 送信イベントのクローズ
  end;
end;

{ データの送信 }
procedure TWPRCComm.Write(const Buffer; Size: DWord);
var
  dwError: DWord;                                       // エラー取得用
  Stat: TComStat;                                       // COMSTAT構造体
  dwBytesWritten: DWord;                                // 書き込み済みサイズポインター
  WaitSize: DWord;                                      // 書き込み待ちサイズ
begin
  if FSeterr < 0 then
    raise ECommError.Create(Not_CommOpen);              // "通信が開始されていない。"エラー表示
  if Size = 0 then exit;                                // 送信データ長に０は無い
  if FOutQueueSize < Size then
    raise ECommError.Create(Over_Length);               // "送信データ長が長すぎる。"エラー表示

// 書き込み待ちサイズ(WaitSize) ﾊﾞｯﾌｧ残りサイズ(Stat.cbOutQue)がこれより小さくなったら書き込む、
// 先に計算をしておかないと、repeat Until で正しく判断出来ない

  WaitSize := FOutQueueSize - Size;                // 書き込み待ちサイズ

// 送信キューが空くのを待つ、Application.ProcessMessages があると送信データーの順番が狂います。
// Application.ProcessMessagesは、他のプロセスの実行許可で、無いと閉ループの為、
// 他のプロセスが停止しますが、ここでは、送信の順番の前後が反対になるときがあります。
// 先に空き調べて送信するか、空きイベントを使用して、ここでループしないように注意して下さい。

  if not ClearCommError(FHandle, dwError, @Stat) then   // エラークリア
                  raise ECommError.Create(ClCommErr);   // ポートエラー表示

  if not FwriteWait then                                // ライトウエイトが無い場合のみ
    begin                                               // ブッファ残りサイズ確認
      repeat
      {
        Application.ProcessMessages;
      }
        if not ClearCommError(FHandle, dwError, @Stat) then  // バッファ残りサイズ取得
                  raise ECommError.Create(ClCommErr);   // ポートエラー表示
      until Stat.cbOutQue <= WaitSize;                  // 残りが待ちサイズより小さくなったら次へ
    end;
                                                        // 書き込み処理
  if not WriteFile(FHandle, Buffer, Size,               // ｵｰﾊﾞｰﾗｯﾌﾟ処理の場合殆どがFalseで戻る
                        dwBytesWritten, @FWriteOs) then
    begin                                               // 書き込み終了しないときの処理
      if GetLastError = ERROR_IO_PENDING then           // ｵｰﾊﾞｰﾗｯﾌﾟ処理中なら
        begin                                           // ｵｰﾊﾞｰﾗｯﾌﾟ処理状態取得FwriteWaitがFalseなら
          if not GetOverlappedResult(FHandle, FWriteOs, // 即戻る、書込終了ならTrue、未だならFalse
                  dwBytesWritten, FwriteWait) then      // True だと書き込み終了まで戻らない
            if GetLastError <> ERROR_IO_INCOMPLETE then // 処理未完了ではない場合異常終了
              if not ClearCommError(FHandle, dwError, @Stat) then  // デバイスエラー情報クリア
                  raise ECommError.Create(ClCommErr);              // ポートエラー表示
        end
        else
        begin                                           // その他のエラー発生
          if not ClearCommError(FHandle, dwError, @Stat) then   // デバイスエラー情報のクリアと取得
              raise ECommError.Create(ClCommErr)                // ポートエラー表示
            else
              raise ECommReadWriteError.Create(dwError);        // 例外の生成エラー表示
        end;
    end;
  if FwriteWait and (Size > dwBytesWritten) then        // 書き込み指定サイズより書き込みサイズが小さいなら
    begin
      if FSetEvnt and EV_ERR = EV_ERR then              // エラー割り込み設定されていたら
        begin
          FdwErrors := dwError or CE_SENDTIMOEUT;       // 送信タイムアウトエラーセット
          DoCommErrEvent;                               // エラー割り込み
        end;
    end;
end;

{ データの受信 }
procedure TWPRCComm.Read(Buffer: PAnsiChar; Size: DWord);
var
  dwError: DWord;                                       // エラー取得用
  Stat: TComStat;                                       // COMSTAT構造体
  dwLength: DWord;                                      // 読み込み済みサイズポインター
begin
  if FSeterr < 0 then
    raise ECommError.Create(Not_CommOpen);              // "通信が開始されていない。"エラー表示
  if Size = 0 then exit;                                // 受信データ長に０は無い
  if not ClearCommError(FHandle, dwError, @Stat) then   // デバイスエラー情報のクリア
                  raise ECommError.Create(ClCommErr);   // ポートエラー表示
  dwlength := Size;                                     // 読み込み済みサイズ初期化
  if not ReadFile(FHandle, Buffer^, Size,
                              dwLength, @FReadOs) then
    begin                                               // 読み込み終了しない場合の処理
      if GetLastError = ERROR_IO_PENDING then           // オーバーラップ処理中の場合
        begin                                           // オーバーラップ処理状態取得
          if not GetOverlappedResult(FHandle, FReadOs,  // FReadWaitがFalseなら即戻る
                        dwlength, FReadWait) then       // True だと読み込み終了まで戻らない
            if GetLastError <> ERROR_IO_INCOMPLETE then // 処理未完了ではない場合異常終了
              if not ClearCommError(FHandle, dwError, @Stat) then  // デバイスエラー情報クリア
                  raise ECommError.Create(ClCommErr);   // ポートエラー表示
        end
        else
        begin                                           // その他のエラー発生
          if not ClearCommError(FHandle, dwError, @Stat) then      // デバイスエラー情報のクリアと取得
              raise ECommError.Create(ClCommErr)            // ポートエラー表示
            else
              raise ECommReadWriteError.Create(dwError);    // 例外の生成エラー表示
        end;
    end;
  if FReadWait and (Size > dwLength) then               // 読み込み指定サイズより読み込みサイズ小さい場合
    begin
      if FSetEvnt and EV_ERR = EV_ERR then              // エラー割り込み設定されていたら
        begin
          FdwErrors := dwError or CE_READTIMOEUT;       // 受信タイムアウトエラーセット
          DoCommErrEvent;                               // エラー割り込み
        end;
    end;
end;

{ 文字列の送信 }
procedure TWPRCComm.SendString(S: Ansistring);
begin
  if FSeterr < 0 then
    raise ECommError.Create(Not_CommOpen);              // "通信が開始されていない。"エラー表示
  Write(PAnsichar(S)^, Length(S));                          // 送信処理
end;

{ 送信バッファ残り容量調査}
function TWPRCComm.GetRemainSize:Cardinal;
var
  Stat: TComStat;                                       // COMSTAT構造体
  dwErrors: DWord;                                      // エラー取得用
begin
  if FSeterr < 0 then                                   // ポートがオープンされていなかったら
      Result := 0                                       // 0を返す
    else
    begin
      if not ClearCommError(FHandle, dwErrors, @Stat) then  // エラー及びバッファ残りサイズ取得
                  raise ECommError.Create(ClCommErr);   // ポートエラー表示
      Result := Stat.cbOutQue;                          // バッファ残りサイズを返す
    end;
end;

{ 送信バッファ空き容量調査}
function TWPRCComm.GetSendSpace:Cardinal;               // 送信バッファ空き容量調査
var
  Stat: TComStat;                                       // COMSTAT構造体
  dwErrors: DWord;                                      // エラー取得用
begin
  if FSeterr < 0 then
    raise ECommError.Create(Not_CommOpen);              // "通信が開始されていない。"エラー表示
  if not ClearCommError(FHandle, dwErrors, @Stat) then  // エラー及びバッファ空サイズ取得
                  raise ECommError.Create(ClCommErr);   // ポートエラー表示
  Result := FOutQueueSize - Stat.cbOutQue;              // 空き容量計算戻し
end;

{ 受信バッファ受信容量調査}
function TWPRCComm.GetReceiveSize:Cardinal;             // 受信バッファ受信容量調査
var
  Stat: TComStat;                                       // COMSTAT構造体
  dwErrors: DWord;                                      // エラー取得用
begin
  if FSeterr < 0 then
    raise ECommError.Create(Not_CommOpen);              // "通信が開始されていない。"エラー表示
  if not ClearCommError(FHandle, dwErrors, @Stat) then  // エラー及びバッファ受信サイズ取得
                  raise ECommError.Create(ClCommErr);   // エラー表示
  Result := Stat.cbInQue;                               // 受信容量
end;

{ ブレークの送信 }
procedure TWPRCComm.SendBreak;
var
    StartTime, Endtime, BreakTime: Cardinal;                // Cardinal48日間On時ｶｳﾝﾀｰｵｰﾊﾞｰﾌﾛｰ対策
begin
  if FSeterr < 0 then
    raise ECommError.Create(Not_CommOpen);                  // "通信が開始されていない。"エラー表示
  if not SetCommBreak(FHandle) then                         // ブレークセット
    raise ECommReadWriteError.Create(GetLastError);         // セットできなかったらエラー
  StartTime := GetTickCount;                                // スタート時間取得
  BreakTime := 0;                                           // ブレーク時間リセット
  while BreakTime < FBreakSendTime do                       // ブレーク時間 Wait
    begin
      Application.ProcessMessages;
      Endtime := GetTickCount;                              // ブレーク時間計算
      if Endtime >= StartTime then
          BreakTime := Endtime - StartTime
        else
          BreakTime := not StartTime + Endtime + 1;
    end;
  ClearCommBreak(FHandle);                                  // ブレークリセット
end;

{ COMM Open確認 }
function TWPRCComm.GetOpenCheck: Boolean;                   // COMM Open確認
begin
  Result := False;                                          // not Open 設定
  if FSeterr >= 0 then Result := True;                      // FSeterrが0 より大きければ、Openを返す
end;

{ 一文字送信}
procedure TWPRCComm.TransmitChar(OneChar: AnsiChar;  ResultBool:  PBoolean);  // 一文字直接送信
begin
  if FSeterr < 0 then
    raise ECommError.Create(Not_CommOpen);                  // "通信が開始されていない。"エラー表示
  ResultBool^ := TransmitCommChar(FHandle, OneChar);        // USB->RS232Cの場合このモードは非常遅い
end;

{ ----- 受信割り込み処理  -------------------------------------------}

procedure TWPRCComm.WndProcComm(var Msg: TMessage);               // WaitCommEvent 呼び出しルーチン
var
  dwEvtMask : DWord;
  Stat: TComStat;                                                 // COMSTAT構造体
  dwErrors: DWord;
begin
  with Msg do
    begin
      if Msg = WM_USER then
        begin
          dwEvtMask := wParam;                                    // イベント情報
          try
            ClearCommError(FHandle, dwErrors, @Stat);             // エラー及びバッファ受信サイズ取得

            // USB<->RS232の場合Breakをエラーデーターの中から検出する。
            // USB<->RS232の場合フレームエラーが先で、ブレーク割り込みが発生しない事が有るので、
            // ブレークをタイマーで遅らせてエラーデーターの中から検出ブレーク割り込みを発生させる

            // エラーフラグの中に、ブレークフラグがセットされている場合先に処理
            if FSetEvnt and EV_BREAK = EV_BREAK then              // ブレーク割り込みが指定されている場合
              begin
                if dwErrors and CE_BREAK = CE_BREAK then          // エラーデーターにブレークがあった場合
                  begin
                    SetEnabled(False);                            // ブレークチェックタイマー停止
                    FCE_FRAME := False;                           // フレームエラーフラグ取り消し
                    dwEvtMask := dwEvtMask and not EV_ERR;        // イベントマスクから EV_ERR 消去 ブレーク とエラーが両方セット
                  end                                             // される事があるのでエラーを消去
                  else                                            // ブレークが無かったら
                  begin
                    SetEnabled(True);                             // ブレークチェックタイマースタート
                    if FSetEvnt and EV_ERR = EV_ERR then          // エラー割り込みが指定されている場合
                      if dwErrors and CE_FRAME = CE_FRAME then    // フレームエラーが有ったら ブレークエラーの前にフレームエラーがでる
                        begin
                          FCE_FRAME := True;                      // フレームエラーフラグセット、ブレークが無かった場合、
                                                                  // フレームエラーを 発生させるため
                          dwErrors := dwErrors and not CE_FRAME;  // フレームエラー消去
                        end
                        else
                          FCE_FRAME := False;                     // フレームエラーフラグ取り消し
                  end;
              end;
            FdwErrors := dwErrors;                                // エラー処理用フラグに保存

            // ここからは通常処理 -------------------------
            if dwEvtMask and EV_RXCHAR = EV_RXCHAR then             // イベント処理
                DoCommReceive                                       // EV_RXCHAR  文字受信
              else if dwEvtMask and EV_RXFLAG = EV_RXFLAG then
                  DoCommEventChar                                   // EV_RXFLAG  割り込み文字受信
                else if dwEvtMask and EV_TXEMPTY = EV_TXEMPTY then
                    DoCommTransmit;                                 // EV_TXEMPTY 送信バッファーが空
            if dwEvtMask and EV_ERR = EV_ERR then
                DoCommErrEvent                                      // EV_ERR     受信エラーが発生
              else if dwEvtMask <> 0 then
                DoCommEvent(dwEvtMask);                             // EV_BREAK   ブレーク信号受信
                                                                    // EV_CTS     CTS信号の変化
                                                                    // EV_DSR     DSR信号の変化
                                                                    // EV_RING    RI信号検知
                                                                    // EV_RLSD    RLSD信号の変化
          except
            Application.HandleException(self);                      // イベントハンドラーで例外発生
          end;
        end
        else
          Result := DefWindowProc(FWPRCHandle, Msg, wParam, lParam);   //デフォルトのウィンドウ プロシージャを呼び出します
    end;
end;


{ ----- 受信スレッド関数 -------------------------------------------}

{ 受信スレッド　開始処理 }
constructor TWPRCCommWatch.Create(AWPrcH: HWND; ComDev: THandle);
begin
  inherited Create(True);                                   // サスペンド状態で作成
  FWPrcH := AWPrcH;                                         // オーナーの保存
  FComDev := ComDev;                                        // 通信ハンドルの保存
  Priority := tpNormal;                                     // 優先順位通常に設定
  FreeOnTerminate := True;                                  // 終了時オブジェクトを破棄
  Resume;                                                   // スレッドの実行開始
end;

{ 受信スレッド　メイン処理 }
procedure TWPRCCommWatch.Execute;
var
  dwEvtMask: DWord;
begin
  while not Terminated do                                   // 接続中はループする FThread.Terminate で終了
    begin
      dwEvtMask := 0;                                       // 初期化USBRS232C接続切断時 dwEvtMask が不定になるのを防止する
      WaitCommEvent(FComDev, dwEvtMask, nil);               // 通信イベント発生の待機
      if not Terminated and (dwEvtMask <> 0) then           // スレッド終了していなかったら、dwEvtMaskがセットされていたら
          SendMessage(FWPrcH, WM_USER, dwEvtMask, 0);       // 受信メッセージ送信
    end;
end;

{----- エラー表示関数群 --------------------------------------------}

{ オープンエラーの表示 }
constructor ECommOpenError.Create(OpenErrorCode: Integer);
var
  msg: string;
begin
  FErrorCode := OpenErrorCode;
  case FErrorCode of
    -3 : msg := Format('送信イベントが作成できない ErrorCode = %d', [FErrorCode]);
    -2 : msg := Format('受信イベントが作成できない ErrorCode = %d', [FErrorCode]);
    -1 : msg := Format('ポート オープンエラー ErrorCode = %d', [FErrorCode]);
  else
         msg := Format('オープンエラー ErrorCode = %d', [FErrorCode]);
  end;
  inherited Create(msg);
end;

{ 入出力エラーの表示 }
constructor ECommReadWriteError.Create(ReadWriteErrorCode: DWord);
var
  msg: string;
begin
  FErrorCode := ReadWriteErrorCode;
  msg := '';
  if (FErrorCode and CE_RXOVER)   <> 0 then msg :=       'Receive Queue overflow, ';
  if (FErrorCode and CE_OVERRUN)  <> 0 then msg := msg + 'Receive Overrun Error, ';
  if (FErrorCode and CE_RXPARITY) <> 0 then msg := msg + 'Receive Parity Error, ';
  if (FErrorCode and CE_FRAME)    <> 0 then msg := msg + 'Receive Framing error, ';
  if (FErrorCode and CE_BREAK)    <> 0 then msg := msg + 'Break Detected, ';
  if (FErrorCode and CE_TXFULL)   <> 0 then msg := msg + 'Transmit Queue is full, ';
  if (FErrorCode and CE_IOE)      <> 0 then msg := msg + 'Communications device I/O Error, ';
  if (FErrorCode and CE_MODE)     <> 0 then msg := msg + 'Requested mode unsupported, ';
  if (FErrorCode and CE_SENDTIMOEUT) <> 0 then msg := msg + 'Transmit Timeout, ';
  if (FErrorCode and CE_READTIMOEUT) <> 0 then msg := msg + 'Receive Timeout, ';
//  *******   Win95 only parallel device  *********
{
  if (FErrorCode and CE_PTO) <> 0 then      msg := msg + 'LPTx Timeout, ';
  if (FErrorCode and CE_DNS) <> 0 then      msg := msg + 'LPTx Device not selected, ';
  if (FErrorCode and CE_OOP) <> 0 then      msg := msg + 'LPTx Out-Of-Paper, ';
}
  if msg = '' then msg := 'Unknown error'
              else msg := Copy(msg, 1, Length(msg) - 2);    // -2 は最後の　', '
  inherited Create(msg);
end;


{----- コンポーネントの登録 ----------------------------------------}

{コンポーネントの登録}
procedure Register;
begin
  RegisterComponents('Comm', [TWPRCComm]);
end;

end.


